var search_data = {"index":{"searchIndex":["object","traclang","bindings","block","decimal","dispatch","executor","expression","form","endofstringerror","immediateread","octal","parser","==()","==()","add()","call_character()","call_lookup()","call_n()","call_return()","call_segment()","clear()","command()","concat()","concat()","console_io()","define_operation()","delete()","delete()","dispatch()","dispatch_form()","dispatch_to_decimal()","dispatch_to_mixed()","dispatch_to_octal()","each()","execute()","fetch()","fetch_binding()","find()","find_chars()","format()","getch()","highline()","in_neutral()","increment()","load()","load_file()","matched_pair_used?()","max_punch()","mnemonic()","new()","new()","new()","new()","new()","new()","new()","new()","newarg()","on()","parens()","parse()","prompt()","punch()","punched()","read()","reading()","restore_dir()","return_empty()","return_force()","return_value()","rotate()","save_dir()","segment_string()","shift()","size()","special_used?()","start_proc()","to_s()","to_s()","to_s()","to_s()","to_trac()","trac_args()","write()","~()"],"longSearchIndex":["object","traclang","traclang::bindings","traclang::block","traclang::decimal","traclang::dispatch","traclang::executor","traclang::expression","traclang::form","traclang::form::endofstringerror","traclang::immediateread","traclang::octal","traclang::parser","traclang::decimal#==()","traclang::octal#==()","traclang::bindings#add()","traclang::form#call_character()","traclang::form#call_lookup()","traclang::form#call_n()","traclang::form#call_return()","traclang::form#call_segment()","traclang::bindings#clear()","traclang::expression#command()","traclang::expression#concat()","traclang::parser#concat()","traclang::immediateread#console_io()","traclang::decimal::define_operation()","traclang::bindings#delete()","traclang::block::delete()","traclang::dispatch#dispatch()","traclang::dispatch::dispatch_form()","traclang::dispatch::dispatch_to_decimal()","traclang::dispatch::dispatch_to_mixed()","traclang::dispatch::dispatch_to_octal()","traclang::bindings#each()","traclang::executor#execute()","traclang::bindings#fetch()","traclang::bindings#fetch_binding()","traclang::form#find()","traclang::form#find_chars()","traclang::form#format()","traclang::immediateread#getch()","traclang::immediateread#highline()","traclang::form#in_neutral()","traclang::form#increment()","traclang::executor#load()","traclang::executor#load_file()","traclang::form#matched_pair_used?()","traclang::form#max_punch()","traclang::dispatch::mnemonic()","traclang::bindings::new()","traclang::decimal::new()","traclang::dispatch::new()","traclang::executor::new()","traclang::expression::new()","traclang::form::new()","traclang::immediateread::new()","traclang::octal::new()","traclang::expression#newarg()","traclang::dispatch::on()","traclang::parser#parens()","traclang::parser#parse()","traclang::executor#prompt()","traclang::form#punch()","traclang::form#punched()","traclang::block::read()","traclang::parser#reading()","traclang::executor#restore_dir()","traclang::dispatch#return_empty()","traclang::dispatch#return_force()","traclang::dispatch#return_value()","traclang::octal#rotate()","traclang::executor#save_dir()","traclang::form#segment_string()","traclang::octal#shift()","traclang::expression#size()","traclang::form#special_used?()","traclang::parser#start_proc()","traclang::decimal#to_s()","traclang::expression#to_s()","traclang::form#to_s()","traclang::octal#to_s()","traclang::form#to_trac()","traclang::expression#trac_args()","traclang::block::write()","traclang::octal#~()"],"info":[["Object","","Object.html","",""],["TracLang","","TracLang.html","","<p>Module containing code for processing TRAC language.\n"],["TracLang::Bindings","","TracLang/Bindings.html","","<p>Binding of name to Form represented by the name.\n"],["TracLang::Block","","TracLang/Block.html","","<p>Class for storing forms under their names.\n"],["TracLang::Decimal","","TracLang/Decimal.html","","<p>Integer for TRAC Language.  Consists of\n<p>string prefix\n<p>sign\n"],["TracLang::Dispatch","","TracLang/Dispatch.html","","<p>Class to dispatch TRAC commands to the proper code.  Also stores the following options needed to run …\n"],["TracLang::Executor","","TracLang/Executor.html","","<p>Executable TRAC commands\n"],["TracLang::Expression","","TracLang/Expression.html","","<p>Model of TRAC neutral string expression.  An expression is an array of strings, corresponding to the …\n"],["TracLang::Form","","TracLang/Form.html","","<p>A form is a defined string in TRAC, along with spaces in it for the insertion of parameters.\n"],["TracLang::Form::EndOfStringError","","TracLang/Form/EndOfStringError.html","","<p>Error when trying to read form off the end of its string.\n"],["TracLang::ImmediateRead","","TracLang/ImmediateRead.html","","<p>Class to do console input.  This is put in a separate class to make it easier to switch between implementations, …\n"],["TracLang::Octal","","TracLang/Octal.html","","<p>TRAC octal number.  Unlike the TracLang::Decimal, any string prefix is discarded.  Bit size is saved …\n"],["TracLang::Parser","","TracLang/Parser.html","","<p>Parser for TRAC input.  Given the input a character at a time, it  creates an active string and then …\n"],["==","TracLang::Decimal","TracLang/Decimal.html#method-i-3D-3D","(d)","<p>Tests for equality.  This is different from numeric equality because prefixes are tested as well as the …\n"],["==","TracLang::Octal","TracLang/Octal.html#method-i-3D-3D","(o)","<p>Tests for equality.  This is different from numeric equality, because size is also tested.\n"],["add","TracLang::Bindings","TracLang/Bindings.html#method-i-add","(*binding)","<p>Adds a binding to the map of bindings.  Will replace a binding with the same name.\n"],["call_character","TracLang::Form","TracLang/Form.html#method-i-call_character","(*)","<p>Returns the character being pointed to and moves the pointer one unit to the right.  Raises a EndOfStringError …\n"],["call_lookup","TracLang::Form","TracLang/Form.html#method-i-call_lookup","(*args)","<p>Returns form string with segment gaps filled with the given arguments.\n"],["call_n","TracLang::Form","TracLang/Form.html#method-i-call_n","(nstr, *)","<p>Returns the given number of characters starting at the current  pointer.  If the number is negative, …\n"],["call_return","TracLang::Form","TracLang/Form.html#method-i-call_return","(*)","<p>Returns the pointers to the start of the form.\n"],["call_segment","TracLang::Form","TracLang/Form.html#method-i-call_segment","(*)","<p>Returns characters between the current pointer and the  next segment gap.\n"],["clear","TracLang::Bindings","TracLang/Bindings.html#method-i-clear","()","<p>Clears all bindings. \n"],["command","TracLang::Expression","TracLang/Expression.html#method-i-command","()","<p>Command for TRAC processor.\n"],["concat","TracLang::Expression","TracLang/Expression.html#method-i-concat","(str)","<p>Adds a string to current argument of the expression.\n"],["concat","TracLang::Parser","TracLang/Parser.html#method-i-concat","(c)","<p>Add character to current expression, ignore if no expression exists\n"],["console_io","TracLang::ImmediateRead","TracLang/ImmediateRead.html#method-i-console_io","()",""],["define_operation","TracLang::Decimal","TracLang/Decimal.html#method-c-define_operation","(symbol)","<p>Defines method for given arithmetical operation.  Result has string prefix of self.  The operations defined …\n"],["delete","TracLang::Bindings","TracLang/Bindings.html#method-i-delete","(name)","<p>Unbinds any Form bound to the given name.\n"],["delete","TracLang::Block","TracLang/Block.html#method-c-delete","(filename)","<p>Deletes given file.\n"],["dispatch","TracLang::Dispatch","TracLang/Dispatch.html#method-i-dispatch","(exp)","<p>Dispatches command to TRAC procedure.  If command received is a TRAC command, it&#39;s looked up in the …\n"],["dispatch_form","TracLang::Dispatch","TracLang/Dispatch.html#method-c-dispatch_form","(sym, type, pos = -1)","<p>Defines mapping from dispatch command to Form method.  The parameters are:\n<p>sym &mdash; Method name in Form to …\n"],["dispatch_to_decimal","TracLang::Dispatch","TracLang/Dispatch.html#method-c-dispatch_to_decimal","(symbol)","<p>Maps a mnemonic to a Decimal operation.  The following are mapped:\n<p>:ad &mdash; Add.  Maps to Decimal.+.\n<p>:su &mdash; Subtract …\n"],["dispatch_to_mixed","TracLang::Dispatch","TracLang/Dispatch.html#method-c-dispatch_to_mixed","(sym)","<p>Maps a mnemonic to a mixed Octal and Decimal operation.  The following are mapped:\n<p>:bs &mdash; Bit Shift.  Mapped …\n"],["dispatch_to_octal","TracLang::Dispatch","TracLang/Dispatch.html#method-c-dispatch_to_octal","(symbol)","<p>Maps a mnemonic to a Octal operation.  The following are mapped:\n<p>:bu &mdash; Bit Union.  Mapped to Octal.|.\n<p>:bi … &mdash; "],["each","TracLang::Bindings","TracLang/Bindings.html#method-i-each","(&blk)","<p>Passes each binding to the given block.\n"],["execute","TracLang::Executor","TracLang/Executor.html#method-i-execute","(str)","<p>Executes a string of TRAC.  If we are in trace mode, wait for user input after executing string.\n"],["fetch","TracLang::Bindings","TracLang/Bindings.html#method-i-fetch","(name)","<p>Fetches the Form with the given name. Returns nil if no Form has the given name.\n"],["fetch_binding","TracLang::Bindings","TracLang/Bindings.html#method-i-fetch_binding","(name)","<p>Fetches the binding for the given name, or nil if nothing has the given name.\n"],["find","TracLang::Form","TracLang/Form.html#method-i-find","(search, start = 0)","<p>Finds the given search string in the string portion of the form, starting  at the given space.  A successful …\n"],["find_chars","TracLang::Form","TracLang/Form.html#method-i-find_chars","(start)","<p>Returns characters from the given position to the next segment gap.\n"],["format","TracLang::Form","TracLang/Form.html#method-i-format","()","<p>Find format of args that works\n"],["getch","TracLang::ImmediateRead","TracLang/ImmediateRead.html#method-i-getch","()","<p>Get character from console input.\n"],["highline","TracLang::ImmediateRead","TracLang/ImmediateRead.html#method-i-highline","()","<p>Get character from console input, doing any translation necessary. \n"],["in_neutral","TracLang::Form","TracLang/Form.html#method-i-in_neutral","(search, *)","<p>Searches for the given string in the form.  If found, returns all characters between the current pointer …\n"],["increment","TracLang::Form","TracLang/Form.html#method-i-increment","(n = 1)","<p>Increments the character pointer by the given amount.\n"],["load","TracLang::Executor","TracLang/Executor.html#method-i-load","(filename, lineno, line)","<p>Executes a line of TRAC loaded from a file.  If an error occurs, an error message will be printed with …\n"],["load_file","TracLang::Executor","TracLang/Executor.html#method-i-load_file","(filename)","<p>Executes TRAC from a file.\n"],["matched_pair_used?","TracLang::Form","TracLang/Form.html#method-i-matched_pair_used-3F","(open, close)","<p>Tests if matched pair of symbols is used anywhere in this form.  Used to find an unused pair for writing …\n"],["max_punch","TracLang::Form","TracLang/Form.html#method-i-max_punch","()","<p>Finds the biggest punch index.\n"],["mnemonic","TracLang::Dispatch","TracLang/Dispatch.html#method-c-mnemonic","(name)","<p>Determines the TRAC mnemonic name from the given method name.  This is  used to map TRAC names to Form …\n"],["new","TracLang::Bindings","TracLang/Bindings.html#method-c-new","(*bindings)","<p>Creates bindings from list of names and Forms.\n"],["new","TracLang::Decimal","TracLang/Decimal.html#method-c-new","(str = '')","<p>Create a TRAC decimal from a string.  Any leading characters are saved as a prefix.  The last sign character …\n"],["new","TracLang::Dispatch","TracLang/Dispatch.html#method-c-new","(**options)","<p>Initializes environment for TRAC with a set of options. Options are:\n<p>bindings &mdash; Bindings to use\n<p>trace &mdash; Turn …\n"],["new","TracLang::Executor","TracLang/Executor.html#method-c-new","(d = nil)","<p>Initialize executor, giving block to store forms in\n"],["new","TracLang::Expression","TracLang/Expression.html#method-c-new","()","<p>Creates new active expression.\n"],["new","TracLang::Form","TracLang/Form.html#method-c-new","(value)","<p>Creates a new form with the given value.\n"],["new","TracLang::ImmediateRead","TracLang/ImmediateRead.html#method-c-new","()","<p>Creates class with console input handler depending on operating system.\n"],["new","TracLang::Octal","TracLang/Octal.html#method-c-new","(str = '')","<p>Creates a TRAC octal. Any leading non-numeric characters are ignored.\n<p>If there are no octal characters, …\n"],["newarg","TracLang::Expression","TracLang/Expression.html#method-i-newarg","()","<p>Signals a new argument is starting.\n"],["on","TracLang::Dispatch","TracLang/Dispatch.html#method-c-on","(sym)","<p>Defines a TRAC command to be added to the dispatch table. The following commands are defined.\n<p><em>System Commands</em> …\n"],["parens","TracLang::Parser","TracLang/Parser.html#method-i-parens","(c)","<p>Handler while reading inside protective parentheses.  Copies all characters to current expression while …\n"],["parse","TracLang::Parser","TracLang/Parser.html#method-i-parse","(str, &blk)","<p>Parses the given string and executes it, until the  active string is empty.\n"],["prompt","TracLang::Executor","TracLang/Executor.html#method-i-prompt","()","<p>Executes TRAC from an interactive prompt.\n"],["punch","TracLang::Form","TracLang/Form.html#method-i-punch","(punch_in, n)","<p>Adds segement gaps for one punch.\n"],["punched","TracLang::Form","TracLang/Form.html#method-i-punched","()","<p>Checks if any punches have been done on this form.\n"],["read","TracLang::Block","TracLang/Block.html#method-c-read","(filename, dispatch)","<p>Reads block from the given file.  The file may have any valid TRAC commands in it, as well as ordinary …\n"],["reading","TracLang::Parser","TracLang/Parser.html#method-i-reading","(c, &blk)","<p>Handler while actively reading the active string.  If you start an expression,  switch to the start_proc …\n"],["restore_dir","TracLang::Executor","TracLang/Executor.html#method-i-restore_dir","()","<p>Restores saved directory.\n"],["return_empty","TracLang::Dispatch","TracLang/Dispatch.html#method-i-return_empty","()","<p>Returns empty string.  All returns are wrapped in a hash containing the return value and the force flag. …\n"],["return_force","TracLang::Dispatch","TracLang/Dispatch.html#method-i-return_force","(val)","<p>Returns value and forces it to the active string.\n"],["return_value","TracLang::Dispatch","TracLang/Dispatch.html#method-i-return_value","(val)","<p>Returns value.  All returns are wrapped in a hash containing the return value and the force flag.\n"],["rotate","TracLang::Octal","TracLang/Octal.html#method-i-rotate","(n)","<p>Rotates octal bits by the given amount.\n"],["save_dir","TracLang::Executor","TracLang/Executor.html#method-i-save_dir","(filename)","<p>Saves original save_dir from dispatch, set dispatch save_dir to dir of given filename.\n"],["segment_string","TracLang::Form","TracLang/Form.html#method-i-segment_string","(*punches)","<p>Add segment gaps for multiple punches.\n"],["shift","TracLang::Octal","TracLang/Octal.html#method-i-shift","(n)","<p>Shifts octal bits by the given amount.\n"],["size","TracLang::Expression","TracLang/Expression.html#method-i-size","()","<p>Returns current number of arguments in expression.\n"],["special_used?","TracLang::Form","TracLang/Form.html#method-i-special_used-3F","(char)","<p>Test if given special character is used anywhere in this form.  Used to find an unused special character …\n"],["start_proc","TracLang::Parser","TracLang/Parser.html#method-i-start_proc","(c, &blk)","<p>Handler for the start of an expression.  Mark the expression as active or not, depending on whether it …\n"],["to_s","TracLang::Decimal","TracLang/Decimal.html#method-i-to_s","()","<p>Returns string value of decimal.  A sign is added to negative zeros.\n"],["to_s","TracLang::Expression","TracLang/Expression.html#method-i-to_s","()","<p>String version of expression, used when trace is on\n"],["to_s","TracLang::Form","TracLang/Form.html#method-i-to_s","()","<p>Converts this form into a string for display.  Follows format of TRAC display defined in language definition. …\n"],["to_s","TracLang::Octal","TracLang/Octal.html#method-i-to_s","()","<p>Converts octal number to string.  Returns a string &lt;size&gt; digits long.\n"],["to_trac","TracLang::Form","TracLang/Form.html#method-i-to_trac","(name)","<p>Converts current state of this form into TRAC commands.\n"],["trac_args","TracLang::Expression","TracLang/Expression.html#method-i-trac_args","()","<p>Arguments for TRAC command.\n"],["write","TracLang::Block","TracLang/Block.html#method-c-write","(filename, bindings)","<p>Writes block to the given file.  Block is written with the following:\n<p>Version of the TRAC Language processor …\n"],["~","TracLang::Octal","TracLang/Octal.html#method-i-~","()","<p>Bit complement.\n"]]}}